#!/usr/bin/env python

import getopt,sys,os
sys.path.append('/usr/local/objdictgen/')
import confignode
import genpv_cfile
from types import *

from nodemanager import *

def usage():
        print "\nusage:"
        print "\n   %s objdictfile cfile_basename [pdomax]\n"%sys.argv[0]

try:
        opts, args = getopt.getopt(sys.argv[1:], "h", ["help"])
except getopt.GetoptError:
        # print help information and exit:
                usage()
                sys.exit(2)

for o, a in opts:
        if o in ("-h", "--help"):
                usage()
                sys.exit()

fileIn = ""
fileOut = ""
if len(args) == 2:
        fileIn = args[0]
        fileOut = args[1]
        pdomax = 5
elif len(args) == 3:
        fileIn = args[0]
        fileOut = args[1]
        pdomax = int(args[2])
else:
        usage()
        sys.exit()

if __name__ == '__main__':
        if fileIn != "" and fileOut != "":
                manager = NodeManager()
                if os.path.isfile(fileIn):
                        print "parsing input file"
                        result = manager.OpenFileInCurrent(fileIn)
                        if not isinstance(result, (StringType, UnicodeType)):
                                Node = result
                        else:
                                print result
                                sys.exit(-1)
                else:
                        print "%s is not a valid file!"%fileIn
                        sys.exit(-1)

                print "writing output file"
                result = genpv_cfile.genfile(fileIn, fileOut,
                                             manager.CurrentNode, pdomax)
                if isinstance(result, (UnicodeType, StringType)):
                        print result
                        sys.exit(-1)
                print "done"

